"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const StyleSheet_1 = __importDefault(require("vue-styled-components/lib/models/StyleSheet"));
const generateAlphabeticName_1 = __importDefault(require("vue-styled-components/lib/utils/generateAlphabeticName"));
const stylis_1 = __importDefault(require("stylis"));
const hash_1 = __importDefault(require("glamor/lib/hash"));
class StyleNode {
    constructor() {
        this.inserted = {};
        if (!StyleSheet_1.default.injected)
            StyleSheet_1.default.inject();
        this.insertedRule = StyleSheet_1.default.insert("");
    }
    appendCss(css) {
        const hash = hash_1.default(css);
        if (!this.inserted[hash]) {
            const selector = generateAlphabeticName_1.default(hash);
            this.inserted[hash] = selector;
            this.insertedRule.appendRule(stylis_1.default("." + selector, css));
        }
        return this.inserted[hash];
    }
}
// global instance cache
const nodes = {};
function injectAndGenerateClassName(strings, ...interpolations) {
    if (!StyleSheet_1.default.injected)
        StyleSheet_1.default.inject();
    const rawHash = hash_1.default(strings.raw[0]);
    if (!nodes[rawHash]) {
        nodes[rawHash] = new StyleNode();
    }
    const node = nodes[rawHash];
    const css = String.raw(strings, ...interpolations);
    return node.appendCss(css);
}
exports.default = { class: injectAndGenerateClassName };
